/****************************************************************
 *                                                              *
 *  Copyright (C) 2003-2007 Christoffer Owe                     *
 *  For conditions of distribution and use, see License.txt     *
 *                                                              *
 ****************************************************************/

#include "ged2xml.h"
#include "gc_address.h"

BOOL GC_ADDRESS::Import(GEDCOMFILE& file)
{
	STRING* tmp;

	int TopLevel = file.GetLevel();
	while (file.GetLevel()==TopLevel &&
		(file.GetTag()==TAG_ADDR ||
		file.GetTag()==TAG_PHON ||
		file.GetTag()==TAG_FAX ||
		file.GetTag()==TAG_EMAIL ||
		file.GetTag()==TAG_WWW))
	{
		if (file.GetTag()==TAG_ADDR)
		{
			tmp = new STRING(file.GetText());
			AddressLines.Add(tmp);
			file.NextLine();
			if (!file.InterpretLine())
				return (FALSE);
			while (file.GetLevel()>TopLevel)
			{
				switch(file.GetTag())
				{
				case TAG_ADR1:
				case TAG_ADR2:
				case TAG_CITY:
				case TAG_STAE:
				case TAG_POST:
				case TAG_CTRY:
					file.PrintError(ERROR_IGNORE,TRUE);
					if (!file.NextLine())
						return FALSE;
					break;
				case TAG_CONT:
					tmp = new STRING(file.GetText());
					AddressLines.Add(tmp);
					if (!file.NextLine())
						return FALSE;
					break;
				default:
					if (!file.IllegalTag())
						return FALSE;
					break;
				}
				if (!file.InterpretLine())
					return (FALSE);
			}
		}
		else if (file.GetTag()==TAG_PHON)
		{
			Phon = file.GetText();
			if (!file.NextLine())
				return FALSE;
		}
		else if (file.GetTag()==TAG_FAX)
		{
			Fax = file.GetText();
			if (!file.NextLine())
				return FALSE;
		}
		else if (file.GetTag()==TAG_EMAIL)
		{
			Email = file.GetText();
			if (!file.NextLine())
				return FALSE;
		}
		else if (file.GetTag()==TAG_WWW)
		{
			WWW = file.GetText();
			if (!file.NextLine())
				return FALSE;
		}
		if (!file.InterpretLine())
			return (FALSE);
	}
	return (TRUE);
}