/****************************************************************
 *                                                              *
 *  Copyright (C) 2003,2005 Christoffer Owe                     *
 *  For conditions of distribution and use, see License.txt     *
 *                                                              *
 ****************************************************************/

#include <Windows.h>
#include <Shlwapi.h>
#include "ged2xml.h"
#include "gc_family.h"

BOOL GC_FAMILY::Import(GEDCOMFILE& file,VECTOR<EVENTTYPE*>& et,VECTOR<GC_SOURCE*>& Sources,VECTOR<GC_SOURCECITE*>& Sourcerefs)
{
	GC_EVENT* Event;
	GC_SOURCECITE* Sourceref;
	GC_NOTE* Note;
	TCHAR* ptr;
	BOOL result = TRUE;

	if (!file.NextLine())
		return FALSE;
	if (!file.InterpretLine())
		return FALSE;
	while (file.GetLevel()>0 && result)
	{
		switch(file.GetTag())
		{
		case TAG_HUSB:
			ptr = file.GetPointer();
			StrCpy(Husb,ptr);
			result = file.NextLine();
			break;
		case TAG_WIFE:
			ptr = file.GetPointer();
			StrCpy(Wife,ptr);
			result = file.NextLine();
			break;
		case TAG_CHIL:
			ptr = file.GetPointer();
			Children.Add(ptr);
			result = file.NextLine();
			break;
		case TAG_ANUL:
		case TAG_CENS:
		case TAG_DIV:
		case TAG_DIVF:
		case TAG_ENGA:
		case TAG_MARR:
		case TAG_MARB:
		case TAG_MARC:
		case TAG_MARL:
		case TAG_MARS:
		case TAG_EVEN:
		case TAG_SLGS:
			Event = new GC_EVENT;
			result = Event->Import(file,et,Sources,Sourcerefs,2);
			Events.Add(Event);
			break;
		case TAG_NCHI:
		case TAG_SUBM:
		case TAG_REFN:
		case TAG_RIN:
			file.PrintError(ERROR_IGNORE,TRUE);
			result = file.NextLine();
			break;
		case TAG_SOUR:
			Sourceref = new GC_SOURCECITE();
			result = Sourceref->Import(file,Sources);
			SourcerefIDs.Add(Sourcerefs.Add(Sourceref));
			break;
		case TAG_NOTE:
			Note = new GC_NOTE();
			result = Note->ImportInfo(file,Sources,Sourcerefs);
			Notes.Add(Note);
			break;
		case TAG_CHAN:
			result = Change.Import(file);
			break;
		default:
			result = file.IllegalTag();
			break;
		}
		if (!result)
			return FALSE;
		if (!file.InterpretLine())
			return (FALSE);
	}
	return TRUE;
}