/****************************************************************
 *                                                              *
 *  Copyright (C) 2003-2009 Christoffer Owe                     *
 *  For conditions of distribution and use, see License.txt     *
 *                                                              *
 ****************************************************************/

#ifndef __GC_NOTE
#define __GC_NOTE

#include "common.h"
#include "gedcom.h"

class GC_SOURCE;
class GC_SOURCECITE;

// Class for a note record
class GC_NOTEREC
{
public:
	STRING Note;

	BOOL Import(GEDCOMFILE&,IDTABLE* NoteIDs);
};

// Class for a note structure (or note reference)
class GC_NOTE
{
public:
	TCHAR NoteID[XREFSIZE+1];
	STRING Note;
	IDLIST SourcerefIDs;

	GC_NOTE(){NoteID[0]=0;}
	BOOL ImportNote(GEDCOMFILE&);
	BOOL ImportInfo(GEDCOMFILE&,VECTOR<GC_SOURCE*>& Sources,VECTOR<GC_SOURCECITE*>& Sourcerefs);
};

// Class for a string which may use CONT/CONC
class GC_STRING
{
public:
	STRING Text;

	BOOL Import(GEDCOMFILE&);
};

#endif