/****************************************************************
 *                                                              *
 *  Copyright (C) 2003-2009 Christoffer Owe                     *
 *  For conditions of distribution and use, see License.txt     *
 *                                                              *
 ****************************************************************/

#include <Windows.h>
#include <Shlwapi.h>
#include "ged2xml.h"
#include "gc_repository.h"

BOOL GC_REPOSITORY::Import(GEDCOMFILE& file)
{
	file.NextLine();
	if (!file.InterpretLine())
		return (FALSE);
	while (file.GetLevel()>0)
	{
		switch(file.GetTag())
		{
		case TAG_REFN:
		case TAG_RIN:
			file.PrintError(ERROR_IGNORE,TRUE);
			file.NextLine();
			break;
		case TAG_NAME:
			Name = file.GetText();
			file.NextLine();
			break;
		case TAG_NOTE:
			if (!Note.ImportNote(file))
				return FALSE;
			break;
		case TAG_ADDR:
			if (!Address.Import(file))
				return FALSE;
			break;
		case TAG_CHAN:
			if (!Change.Import(file))
				return FALSE;
			break;
		default:
			file.IllegalTag();
			break;
		}
		if (!file.InterpretLine())
			return (FALSE);
	}
	return (TRUE);
}

BOOL GC_REPREF::Import(GEDCOMFILE& file)
{
	BOOL result = TRUE;

	int TopLevel = file.GetLevel();
	StrCpy(Rep,file.GetPointer());
	if (!file.NextLine())
		return FALSE;
	if (!file.InterpretLine())
		return FALSE;
	while (file.GetLevel()>TopLevel)
	{
		switch(file.GetTag())
		{
		case TAG_CALN:
			Callnumber = file.GetText();
			result = file.NextLine();
			break;
		case TAG_NOTE:
			result = Note.ImportNote(file);
			break;
		default:
			result = file.IllegalTag();
			break;
		}
		if (!result)
			return FALSE;
		if (!file.InterpretLine())
			return FALSE;
	}
	return TRUE;
}