/****************************************************************
 *                                                              *
 *  Copyright (C) 2003-2009 Christoffer Owe                     *
 *  For conditions of distribution and use, see License.txt     *
 *                                                              *
 ****************************************************************/

#ifndef __GENXML
#define __GENXML

#include <windows.h>
#include "ged2xml.h"
#include "Data.h"
#include "gc_header.h"
#include "gc_submitter.h"
#include "gc_repository.h"
#include "gc_source.h"
#include "gc_event.h"
#include "gc_person.h"
#include "gc_family.h"
#include "gc_place.h"
#include "gc_address.h"

class GENXML
{
private:
	HANDLE GXFile;
	long cPersons;
	long cAssertions;

	void Write(TCHAR*);
	void Write(STRING&);
	CONVERSIONDATA* ConvData;
public:
	GENXML(HANDLE file,CONVERSIONDATA* convdata);
	~GENXML();
	void Header(GC_HEADER &header,VECTOR<GC_SUBMITTER*>&);
	long Repository(VECTOR<GC_REPOSITORY*>&,VECTOR<GC_NOTEREC*> &Notes,IDTABLE &NoteIDs);
	//long Source(VECTOR<GC_SOURCE*>&,VECTOR<GC_SOURCECITE*> &Sourcerefs,IDTABLE&,VECTOR<GC_OBJECTREC*> &Objects,IDTABLE &ObjectIDs,VECTOR<GC_NOTEREC*> &Notes,IDTABLE &NoteIDs);
	long Source(GEDCOMDATA* data,int ObjectStatus);
	long Excerpt(VECTOR<GC_SOURCECITE*>&,IDTABLE&,VECTOR<GC_NOTEREC*> &Notes,IDTABLE &NoteIDs);
	long Eventtype(VECTOR<EVENTTYPE*>&);
	//long Person(VECTOR<GC_PERSON*>&,VECTOR<GC_OBJECTREC*> &Objects,IDTABLE &ObjectIDs,VECTOR<GC_NOTEREC*> &Notes,IDTABLE &NoteIDs,int ObjectStatus);
	long Person(GEDCOMDATA* data,int ObjectStatus);
	long Assertion(VECTOR<GC_PERSON*>&,VECTOR<GC_FAMILY*>&,IDTABLE&,VECTOR<GC_NOTEREC*> &Notes,IDTABLE &NoteIDs);
	long Tasks(VECTOR<GC_TODO*>&,IDTABLE&);
	void Total(long iRepositories,long iSources,long iExcerpts,long iEventtypes,long iPersons,long iAssertions,long iTasks);
	void Date(GC_DATE &date);
	inline void SimpleDate(GC_SIMPLEDATE &date,TCHAR* tag){SimpleDate(date,tag,NULL,FALSE);}
	inline void SimpleDate(GC_SIMPLEDATE &date,TCHAR* tag,TCHAR* modifier){SimpleDate(date,tag,modifier,FALSE);}
	void SimpleDate(GC_SIMPLEDATE &date,TCHAR* tag,TCHAR* modifier,BOOL time);
	void Change(GC_CHANGE &change);
	void PersonalName(GC_NAME &name);
	void Place(GC_PLACE &Place);
	void Address(GC_ADDRESS &Address);
	void Note(GC_NOTE &Note,VECTOR<GC_NOTEREC*> &Notes,IDTABLE &NoteIDs);
	void NoteText(GC_NOTE* Note,VECTOR<GC_NOTEREC*> &Notes,IDTABLE &NoteIDs);
	void Excerptref(IDLIST&);
	void Object(GC_OBJECT &Object,VECTOR<GC_OBJECTREC*> &Objects,IDTABLE &ObjectIDs,VECTOR<GC_NOTEREC*> &Notes,IDTABLE &NoteIDs,int ObjectStatus);
	void ObjectBin(TCHAR* szPath);
};

#endif